## CustomShapeSpec

Specification for adding custom shape.

View Source GLShape.ts, line 1856

### Extends

- ShapeSpec

# Members

Type: `Func`

#### # callback Optional

function to call on click

Inherited From:
  - ShapeSpec#callback

View Source GLShape.ts, line 1595

Type: `boolean`

#### # clickable Optional

if true, user can click on object to trigger callback

Inherited From:
  - ShapeSpec#clickable

View Source GLShape.ts, line 1590

Type: `ColorSpec` | `Array`

#### # color Optional

Either a single color for the whole object or an array specifying the color at each vertex (`CustomShapeSpec`).

Inherited From:
  - ShapeSpec#color

View Source GLShape.ts, line 1565

Type: `Array`

#### # faceArr Optional

List of triangles to build the custom shape. Each triangle is defined by the indices of 3 vertices in vertexArr, so the array length should be 3 times the number of faces.

View Source GLShape.ts, line 1871

Type: `number`

#### # frame Optional

if set, only display in this frame of an animation

Inherited From:
  - ShapeSpec#frame

View Source GLShape.ts, line 1615

Type: `boolean`

#### # hidden Optional

if true, do not display object

Inherited From:
  - ShapeSpec#hidden

View Source GLShape.ts, line 1580

Type: `Func`

#### # hover_callback Optional

hover callback

Inherited From:
  - ShapeSpec#hover_callback

View Source GLShape.ts, line 1605

Type: `boolean`

#### # hoverable Optional

if true, user can hover on object to trigger callback

Inherited From:
  - ShapeSpec#hoverable

View Source GLShape.ts, line 1600

Type: `number`

#### # linewidth Optional

width of line for wireframe rendering No longer supported by most browsers

Inherited From:
  - ShapeSpec#linewidth

View Source GLShape.ts, line 1585

Type: `Array`

#### # normalArr Optional

List of normal vectors for each vertex

View Source GLShape.ts, line 1866

Type: `number`

#### # opacity Optional

transparency, between 0 (invisible) and 1 (opaque)

Inherited From:
  - ShapeSpec#opacity

View Source GLShape.ts, line 1570

Type: `Func`

#### # unhover_callback Optional

unhover callback

Inherited From:
  - ShapeSpec#unhover_callback

View Source GLShape.ts, line 1610

Type: `Array`

#### # vertexArr Optional

List of vertex positions

View Source GLShape.ts, line 1861

Type: `boolean`

#### # wireframe Optional

draw as wireframe, not surface

Inherited From:
  - ShapeSpec#wireframe

View Source GLShape.ts, line 1575